#line 1 "dfa_x86.cpp"
//
// Copyright (c) 2003, 2018, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 8;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 1;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RAX_REGN, rax_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RREGN, rRegN_rule, c)
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, no_rax_rdx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, no_rcx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rdi_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, rRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rax_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rbx_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rcx_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rdx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(R15_REGP, r15_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, any_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, rRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, rax_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, rbx_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, no_rax_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, no_rbp_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, rsi_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, no_rax_rbx_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, rdi_RegP_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VLREGF, vlRegF_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100+95)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(REGF, regF_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+95)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VLREGD, vlRegD_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100+95)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(REGD, regD_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+95)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rdx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, rRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, no_rax_rdx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, no_rax_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, no_rcx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rax_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rcx_RegL_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    if(         
#line 3651 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
false
#line 224 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, rFlagsRegUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, rFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecS(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECS, legVecS_rule, c)
        DFA_PRODUCTION__SET_VALID(VECS, MoveLeg2VecS_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECS, vecS_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECD, legVecD_rule, c)
        DFA_PRODUCTION__SET_VALID(VECD, MoveLeg2VecD_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECD, vecD_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM31, rxmm31_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM30, rxmm30_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM29, rxmm29_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM28, rxmm28_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM27, rxmm27_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM26, rxmm26_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM25, rxmm25_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM24, rxmm24_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM23, rxmm23_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM22, rxmm22_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM21, rxmm21_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM20, rxmm20_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM19, rxmm19_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM18, rxmm18_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM17, rxmm17_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM16, rxmm16_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM15, rxmm15_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM14, rxmm14_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM13, rxmm13_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM12, rxmm12_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM11, rxmm11_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM10, rxmm10_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM9, rxmm9_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM8, rxmm8_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM7, rxmm7_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM6, rxmm6_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM5, rxmm5_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM4, rxmm4_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM3, rxmm3_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM2, rxmm2_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM1, rxmm1_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RXMM0, rxmm0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECX, legVecX_rule, c)
        DFA_PRODUCTION__SET_VALID(VECX, MoveLeg2VecX_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECX, vecX_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecY(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECY, legVecY_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECY, vecY_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecZ(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(LEGVECZ, legVecZ_rule, c)
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VECZ, vecZ_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 2673 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 426 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+150;
        DFA_PRODUCTION__SET_VALID(VLREGD, absD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2661 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 437 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 2648 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 456 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+150;
        DFA_PRODUCTION__SET_VALID(VLREGF, absF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2637 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 467 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2199 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 486 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2187 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 497 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2187 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 514 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2175 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 531 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2164 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 548 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2152 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2152 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 582 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2140 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2128 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 618 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2116 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 629 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2116 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 646 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2104 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 663 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2093 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 680 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2081 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 697 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2081 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 714 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2069 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 731 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[0]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI_IMMI_M1, _AddI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI_M1, _AddI__LoadI_memory__immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) &&
        (
#line 7314 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 864 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, decI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI1, _AddI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) &&
        (
#line 7288 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 903 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, incI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI, _AddI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI__LOADI_MEMORY_, _AddI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__RREGI, _AddI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL_RREGL_IMML_M1, _AddL_rRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML_M1, _AddL__LoadL_memory__immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) &&
        (
#line 7436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 1080 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, decL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML1, _AddL__LoadL_memory__immL1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMML1) &&
        (
#line 7410 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 1100 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMML1]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, incL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML32, _AddL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDL_RREGL__LOADL_MEMORY_, _AddL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__RREGL, _AddL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ADDL__LSHIFTL_RREGL_IMMI2_IMML32, _AddL__LShiftL_rRegL_immI2_immL32_rule, c)
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, subP_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, addP_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, addP_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4088 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0 && n->in(2)->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1343 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALEOFFSETNARROW, indPosIndexScaleOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScaleOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2, _AddP__DecodeN_rRegN___LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4071 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0 && n->in(2)->in(3)->as_Type()->type()->is_long()->_lo >= 0
#line 1398 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___CONVI2L_RREGI_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXOFFSETNARROW, indPosIndexOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_RREGI_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_CONVI2L_RREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___CONVI2L_RREGI_, _AddP__DecodeN_rRegN___ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4053 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1453 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSETNARROW, indIndexScaleOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2, _AddP__DecodeN_rRegN___LShiftL_rRegL_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) &&
        
#line 4036 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1508 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALENARROW, indIndexScaleNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        
#line 4019 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1559 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[RREGL]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXNARROW, indIndexNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN__RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4002 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1571 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN__RREGL]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSETNARROW, indIndexOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN__RREGL, _AddP__DecodeN_rRegN__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3986 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1626 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32NARROW, indOffset32Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP32Narrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 3970 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1677 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8NARROW, indOffset8Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP8Narrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3937 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_shift() == Address::times_8)
#line 1728 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDCOMPRESSEDOOPOFFSET, indCompressedOopOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indCompressedOopOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPCompressedOopOffset_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3920 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1779 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALEOFFSET, indPosIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2, _AddP_any_RegP__LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3903 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(3)->as_Type()->type()->is_long()->_lo >= 0
#line 1834 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__CONVI2L_RREGI_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXOFFSET, indPosIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_RREGI_) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_CONVI2L_RREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__CONVI2L_RREGI_, _AddP_any_RegP__ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET, indIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2, _AddP_any_RegP__LShiftL_rRegL_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) &&
        
#line 3870 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1939 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALE, indPosIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScale_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScale_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[RREGL]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP_RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP_RREGL]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET, indIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP_RREGL, _AddP_any_RegP_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP32_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP8_rule, c+110)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADB_MEMORY__IMMI8, _AndI__LoadB_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMU8) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMU8];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMU8, _AndI__LoadUB_memory__immU8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI, _AndI_rRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, and_cmpLTMask_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, and_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__CMPLTMASK_RREGI_RREGI, _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__CMPLTMASK_RREGI_RREGI_RREGI, _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 9481 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2249 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9481 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2284 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 9466 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2319 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9466 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2354 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        (
#line 9421 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2389 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9421 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2424 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) &&
        (
#line 9408 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2459 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9408 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2494 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0_RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 9395 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2529 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9395 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2564 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 9381 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9381 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2634 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI, _AndI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__LOADI_MEMORY_, _AndI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__RREGI, _AndI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADB_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__LOADB_MEMORY_, _AndI_rRegI__LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADB_MEMORY__RREGI, _AndI__LoadB_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI_65535, _AndI_rRegI_immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI_255, _AndI_rRegI_immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMU31];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMU31, _AndI__LoadI_memory__immU31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_65535, _AndI__LoadI_memory__immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_255, _AndI__LoadI_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2UB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI, _AndI__LoadUS_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI_255, _AndI__LoadUS_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMI, _AndI__LoadUB_memory__immI_rule, c)
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _CASTP2X_RREGP_) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_CASTP2X_RREGP_];
        DFA_PRODUCTION__SET_VALID(_ANDL__LOADL_MEMORY___CASTP2X_RREGP_, _AndL__LoadL_memory___CastP2X_rRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_RREGP_) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_RREGP_]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDL__CASTP2X_RREGP___LOADL_MEMORY_, _AndL__CastP2X_rRegP___LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ANDL_RREGL_IMML32, _AndL_rRegL_immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_32BITS]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, zerox_long_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMML_32BITS]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convI2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9852 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3013 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9852 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3045 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL_IMML_M1) &&
        (
#line 9837 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3077 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_ADDL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9837 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3109 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        (
#line 9792 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3141 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9792 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3173 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0_RREGL) &&
        (
#line 9779 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3205 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_SUBL_IMML0_RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0_RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9779 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3237 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0_RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL_IMML_M1) &&
        (
#line 9766 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_XORL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9766 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3301 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL_IMML_M1) &&
        (
#line 9752 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_XORL_RREGL_IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9752 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_RREGL_IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ANDL__LOADL_MEMORY__IMML32, _AndL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDL_RREGL__LOADL_MEMORY_, _AndL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ANDL__LOADL_MEMORY__RREGL, _AndL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_255) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) &&
        (
#line 11316 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 3600 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, array_equalsC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) &&
        (
#line 11300 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 3617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, array_equalsB_rule, c)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ__LOADVECTOR_MEMORY_, _Binary_vecZ__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ_VECZ, _Binary_vecZ_vecZ_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY__LOADVECTOR_MEMORY_, _Binary_vecY__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY_VECY, _Binary_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX__LOADVECTOR_MEMORY_, _Binary_vecX__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX_VECX, _Binary_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], LEGVECY) && STATE__VALID_CHILD(_kids[1], LEGVECY) ) {
      unsigned int c = _kids[0]->_cost[LEGVECY]+_kids[1]->_cost[LEGVECY];
        DFA_PRODUCTION__SET_VALID(_BINARY_LEGVECY_LEGVECY, _Binary_legVecY_legVecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_VCMPPD) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_VCMPPD]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_VCMPPD_IMMI8, _Binary_cmpOp_vcmppd_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RSI_REGP, _Binary_rdi_RegP_rsi_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_RAX_REGI, _Binary_rsi_RegP_rax_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_IMMI, _Binary_rsi_RegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RDX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RDX_REGI, _Binary_rdi_RegP_rdx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RDX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_RDX_REGI, _Binary_rsi_RegP_rdx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RCX_REGI, _Binary_rdi_RegP_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGN]+_kids[1]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGN_RREGN, _Binary_rax_RegN_rRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGL_RREGL, _Binary_rax_RegL_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGI_RREGI, _Binary_rax_RegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGP]+_kids[1]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGP_RREGP, _Binary_rax_RegP_rRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGL__LOADL_MEMORY_, _Binary_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGL_RREGL, _Binary_rRegL_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGP_RREGP, _Binary_rRegP_rRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGN_RREGN, _Binary_rRegN_rRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI__LOADI_MEMORY_, _Binary_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPUCF_RFLAGSREGUCF, _Binary_cmpOpUCF_rFlagsRegUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_RFLAGSREGU, _Binary_cmpOpU_rFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI_RREGI, _Binary_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_RFLAGSREG, _Binary_cmpOp_rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 2021 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Bool()->_test._test != BoolTest::overflow &&
            n->as_Bool()->_test._test != BoolTest::no_overflow
#line 3772 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_VCMPPD, cmpOp_vcmppd_rule, c)
    }
    if(         
#line 4251 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 3781 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF2, cmpOpUCF2_rule, c)
    }
    if(         
#line 4230 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 3792 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF, cmpOpUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(RREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, castX2P_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_ANY_REGP_, _CastP2X_any_RegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_];
        DFA_PRODUCTION__SET_VALID(_CASTP2X__DECODEN_RREGN__, _CastP2X__DecodeN_rRegN___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_RREGP_, _CastP2X_rRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, castPP_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, checkCastPP_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RCX_REGL) && STATE__VALID_CHILD(_kids[1], RDI_REGP) &&
        (
#line 11017 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((ClearArrayNode*)n)->is_large()
#line 3989 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RCX_REGL]+_kids[1]->_cost[RDI_REGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_large_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RCX_REGL) && STATE__VALID_CHILD(_kids[1], RDI_REGP) &&
        (
#line 10958 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!((ClearArrayNode*)n)->is_large()
#line 3998 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RCX_REGL]+_kids[1]->_cost[RDI_REGP]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_CMoveVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_LEGVECY_LEGVECY) &&
        (
#line 7816 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 4043 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_LEGVECY_LEGVECY]+100;
        DFA_PRODUCTION__SET_VALID(LEGVECY, vcmov4D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_CMoveVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_LEGVECY_LEGVECY) &&
        (
#line 7800 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 4087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_LEGVECY_LEGVECY]+100;
        DFA_PRODUCTION__SET_VALID(LEGVECY, vcmov8F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VECY, MoveLeg2VecY_rule, c+100)
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_memUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_memUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_regUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_regUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 11849 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() == NULL && (Universe::narrow_klass_base() == NULL)
#line 4538 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+_kids[1]->_cost[IMMN0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_mem_reg0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 11836 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() != NULL
#line 4547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+_kids[1]->_cost[IMMN0]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMN0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMNKLASS) && STATE__VALID_CHILD(_kids[1], _LOADNKLASS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMNKLASS]+_kids[1]->_cost[_LOADNKLASS_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_mem_imm_klass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMNKLASS]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_imm_klass_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMN) && STATE__VALID_CHILD(_kids[1], _LOADN_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMN]+_kids[1]->_cost[_LOADN_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMN]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], _LOADN_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[_LOADN_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[RREGN]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_immCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+145;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_memCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_reg_CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_immCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+145;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_memCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_reg_CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADB_MEMORY__IMMI8) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADB_MEMORY__IMMI8]+_kids[1]->_cost[IMMI0]+125;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testB_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMU8) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMU8]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testUB_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[IMMI8]+125;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compB_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__RREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDL__LOADL_MEMORY___CASTP2X_RREGP_) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__LOADL_MEMORY___CASTP2X_RREGP_]+_kids[1]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem2_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CASTP2X_RREGP___LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CASTP2X_RREGP___LOADL_MEMORY_]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__LOADL_MEMORY__RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__LOADL_MEMORY__RREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_RREGL__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_RREGL__LOADL_MEMORY_]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_RREGL_IMML32) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_RREGL_IMML32]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CMPLTMASK_RREGI_RREGI, _CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpLTMask0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpLTMask_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP]+_kids[1]->_cost[IMMP0]+1000;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, partialSubtypeCheck_vs_Zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 11754 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 4996 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_mem_reg0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 11741 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCompressedOops || (Universe::narrow_oop_base() != NULL)
#line 5007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMP0]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) &&
        (
#line 11716 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(2)->bottom_type()->reloc() == relocInfo::none
#line 5024 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_mem_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGP]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testU_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testUL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapB_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapS_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7633 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5137 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7608 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5156 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapB_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapS_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapI_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7633 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5231 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapL_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7608 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5250 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_0_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeB_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeS_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeI_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7812 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5325 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, compareAndExchangeL_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7850 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5343 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, compareAndExchangeP_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGN, compareAndExchangeN_rule, c)
    }
}
void  State::_sub_Op_GetAndAddB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7866 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5384 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddB_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddS_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7889 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5407 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddS_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7912 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5430 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddI_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xaddL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        (
#line 7935 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddL_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndSetB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgB_rule, c)
    }
}
void  State::_sub_Op_GetAndSetS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgS_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgI_rule, c)
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xchgL_rule, c)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, xchgP_rule, c)
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, xchgN_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, xchgN_rule, c)
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 3077 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->get_narrowcon() == 0
#line 5542 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMN0, immN0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGN, loadConN0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConN0_rule, c+100)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConN_rule, c+125)
      }
    }
   if ( /* RREGN KNOWN_VALID || */ _cost[RREGN] > 125) {
     DFA_PRODUCTION(RREGN, loadConN_rule, 125)
   }
   if ( /* RAX_REGN KNOWN_VALID || */ _cost[RAX_REGN] > 125) {
     DFA_PRODUCTION(RAX_REGN, loadConN_rule, 125)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConNKlass_rule, c+125)
    }
     DFA_PRODUCTION(RREGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(RAX_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConD(const Node *n){
    {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+125+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+125+95)
    }
    if(         
#line 3228 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
jlong_cast(n->getd()) == 0
#line 5587 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION(REGD, loadConD0_rule, c+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(VLREGD, MoveD2VL_rule, c+100+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100+95)	  // overwrites higher cost rule
    }
   if ( /* REGD KNOWN_VALID || */ _cost[REGD] > 125) {
     DFA_PRODUCTION(REGD, loadConD_rule, 125)
   }
   if ( /* VLREGD KNOWN_VALID || */ _cost[VLREGD] > 125+100) {
     DFA_PRODUCTION(VLREGD, MoveD2VL_rule, 125+100)
   }
   if ( /* STACKSLOTD KNOWN_VALID || */ _cost[STACKSLOTD] > 125+95) {
     DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, 125+95)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+125+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+125+95)
    }
    if(         
#line 3207 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
jint_cast(n->getf()) == 0
#line 5616 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION(REGF, loadConF0_rule, c+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(VLREGF, MoveF2VL_rule, c+100+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100+95)	  // overwrites higher cost rule
    }
   if ( /* REGF KNOWN_VALID || */ _cost[REGF] > 125) {
     DFA_PRODUCTION(REGF, loadConF_rule, 125)
   }
   if ( /* VLREGF KNOWN_VALID || */ _cost[VLREGF] > 125+100) {
     DFA_PRODUCTION(VLREGF, MoveF2VL_rule, 125+100)
   }
   if ( /* STACKSLOTF KNOWN_VALID || */ _cost[STACKSLOTF] > 125+95) {
     DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, 125+95)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3280 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 65535
#line 5639 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 3270 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 255
#line 5647 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 3260 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 24
#line 5655 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 3251 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 16
#line 5663 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3029 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
 _n_get_int__ == 64 
#line 5671 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_64, immI_64_rule, c)
    }
    if(         
#line 3018 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
 _n_get_int__ == 32 
#line 5679 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 3007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ >= 0
#line 5687 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMU31, immU31_rule, c)
    }
    if(         
#line 2996 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
(-32768 <= _n_get_int__) && (_n_get_int__ <= 32767)
#line 5695 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI16, immI16_rule, c)
    }
    if(         
#line 2986 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
(0 <= _n_get_int__) && (_n_get_int__ <= 255)
#line 5703 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMU8, immU8_rule, c)
    }
    if(         
#line 2976 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
(-0x80 <= _n_get_int__) && (_n_get_int__ < 0x80)
#line 5711 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
    }
    if(         
#line 2967 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 5719 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI2, immI2_rule, c)
    }
    if(         
#line 2956 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == -1
#line 5727 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2945 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 1
#line 5735 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI1, immI1_rule, c)
    }
    if(         
#line 2934 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 0
#line 5743 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadConI0_rule, c+50)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadConI_rule, c+100)
      }
    }
   if ( /* RREGI KNOWN_VALID || */ _cost[RREGI] > 100) {
     DFA_PRODUCTION(RREGI, loadConI_rule, 100)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > 100+100) {
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 100+100)
   }
   if ( /* RAX_REGI KNOWN_VALID || */ _cost[RAX_REGI] > 100) {
     DFA_PRODUCTION(RAX_REGI, loadConI_rule, 100)
   }
   if ( /* NO_RCX_REGI KNOWN_VALID || */ _cost[NO_RCX_REGI] > 100) {
     DFA_PRODUCTION(NO_RCX_REGI, loadConI_rule, 100)
   }
   if ( /* RBX_REGI KNOWN_VALID || */ _cost[RBX_REGI] > 100) {
     DFA_PRODUCTION(RBX_REGI, loadConI_rule, 100)
   }
   if ( /* NO_RAX_RDX_REGI KNOWN_VALID || */ _cost[NO_RAX_RDX_REGI] > 100) {
     DFA_PRODUCTION(NO_RAX_RDX_REGI, loadConI_rule, 100)
   }
   if ( /* RCX_REGI KNOWN_VALID || */ _cost[RCX_REGI] > 100) {
     DFA_PRODUCTION(RCX_REGI, loadConI_rule, 100)
   }
   if ( /* RDX_REGI KNOWN_VALID || */ _cost[RDX_REGI] > 100) {
     DFA_PRODUCTION(RDX_REGI, loadConI_rule, 100)
   }
   if ( /* RDI_REGI KNOWN_VALID || */ _cost[RDI_REGI] > 100) {
     DFA_PRODUCTION(RDI_REGI, loadConI_rule, 100)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3300 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 65535
#line 5821 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_65535, immL_65535_rule, c)
    }
    if(         
#line 3290 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 255
#line 5829 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_255, immL_255_rule, c)
    }
    if(         
#line 3196 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 5837 "dfa_x86.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 3185 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 <= _n_get_long__ && _n_get_long__ < 0x80
#line 5845 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML_127, immL_127_rule, c)
    }
    if(         
#line 3174 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 10
#line 5853 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML10, immL10_rule, c)
    }
    if(         
#line 3164 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == -1
#line 5861 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 3154 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 1
#line 5869 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML1, immL1_rule, c)
    }
    if(         
#line 3143 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 0L
#line 5877 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL0_rule, c+50)
    }
    if(         
#line 3132 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == (int) (_n_get_long__)
#line 5893 "dfa_x86.cpp"
 ) {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+70+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+70+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL32_rule, c+70)
      }
    }
    if(         
#line 3121 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == (unsigned int) (_n_get_long__)
#line 5925 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMUL32, immUL32_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+60+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+60+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConUL32_rule, c+60)
      }
    }
    if(         
#line 3110 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
-0x80L <= _n_get_long__ && _n_get_long__ < 0x80L
#line 5957 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMML8, immL8_rule, c)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+150+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+150+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL_rule, c+150)
      }
    }
   if ( /* RREGL KNOWN_VALID || */ _cost[RREGL] > 150) {
     DFA_PRODUCTION(RREGL, loadConL_rule, 150)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 150+100) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 150+100)
   }
   if ( /* NO_RAX_RDX_REGL KNOWN_VALID || */ _cost[NO_RAX_RDX_REGL] > 150) {
     DFA_PRODUCTION(NO_RAX_RDX_REGL, loadConL_rule, 150)
   }
   if ( /* NO_RAX_REGL KNOWN_VALID || */ _cost[NO_RAX_REGL] > 150) {
     DFA_PRODUCTION(NO_RAX_REGL, loadConL_rule, 150)
   }
   if ( /* NO_RCX_REGL KNOWN_VALID || */ _cost[NO_RCX_REGL] > 150) {
     DFA_PRODUCTION(NO_RCX_REGL, loadConL_rule, 150)
   }
   if ( /* RAX_REGL KNOWN_VALID || */ _cost[RAX_REGL] > 150) {
     DFA_PRODUCTION(RAX_REGL, loadConL_rule, 150)
   }
   if ( /* RCX_REGL KNOWN_VALID || */ _cost[RCX_REGL] > 150) {
     DFA_PRODUCTION(RCX_REGL, loadConL_rule, 150)
   }
   if ( /* RDX_REGL KNOWN_VALID || */ _cost[RDX_REGL] > 150) {
     DFA_PRODUCTION(RDX_REGL, loadConL_rule, 150)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3087 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->as_Type()->type()->reloc() == relocInfo::none
            && (n->get_ptr() >> 31) == 0
#line 6020 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP31, immP31_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+60+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP31_rule, c+60)
    }
    if(         
#line 3050 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->get_ptr() == 0
#line 6041 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+50) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP0_rule, c+50)
      }
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP_rule, c+100)
      }
    }
   if ( /* RREGP KNOWN_VALID || */ _cost[RREGP] > 100) {
     DFA_PRODUCTION(RREGP, loadConP_rule, 100)
   }
   if ( /* STACKSLOTP KNOWN_VALID || */ _cost[STACKSLOTP] > 100+100) {
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 100+100)
   }
   if ( /* ANY_REGP KNOWN_VALID || */ _cost[ANY_REGP] > 100) {
     DFA_PRODUCTION(ANY_REGP, loadConP_rule, 100)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > 100) {
     DFA_PRODUCTION(INDIRECT, loadConP_rule, 100)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > 100) {
     DFA_PRODUCTION(MEMORY, indirect_rule, 100)
   }
   if ( /* RAX_REGP KNOWN_VALID || */ _cost[RAX_REGP] > 100) {
     DFA_PRODUCTION(RAX_REGP, loadConP_rule, 100)
   }
   if ( /* RBX_REGP KNOWN_VALID || */ _cost[RBX_REGP] > 100) {
     DFA_PRODUCTION(RBX_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RAX_REGP KNOWN_VALID || */ _cost[NO_RAX_REGP] > 100) {
     DFA_PRODUCTION(NO_RAX_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RBP_REGP KNOWN_VALID || */ _cost[NO_RBP_REGP] > 100) {
     DFA_PRODUCTION(NO_RBP_REGP, loadConP_rule, 100)
   }
   if ( /* RSI_REGP KNOWN_VALID || */ _cost[RSI_REGP] > 100) {
     DFA_PRODUCTION(RSI_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RAX_RBX_REGP KNOWN_VALID || */ _cost[NO_RAX_RBX_REGP] > 100) {
     DFA_PRODUCTION(NO_RAX_RBX_REGP, loadConP_rule, 100)
   }
   if ( /* RDI_REGP KNOWN_VALID || */ _cost[RDI_REGP] > 100) {
     DFA_PRODUCTION(RDI_REGP, loadConP_rule, 100)
   }
   if ( /* R15_REGP KNOWN_VALID || */ _cost[R15_REGP] > 100) {
     DFA_PRODUCTION(R15_REGP, loadConP_rule, 100)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10663 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseXmmI2D
#line 6311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convXI2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10626 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmI2D
#line 6334 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10649 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseXmmI2F
#line 6353 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convXI2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10603 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmI2F
#line 6376 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andI2L_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andI2L_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMU31]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immU31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immI_65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUB2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_RREGI_, _ConvI2L_rRegI__rule, c)
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convL2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X__DECODEN_RREGN__) &&
        (
#line 6749 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 6819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X__DECODEN_RREGN__]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convN2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_RREGP_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_RREGP_]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convP2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) &&
        (
#line 12193 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6886 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_and_restoreMask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) &&
        (
#line 12176 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6895 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) &&
        (
#line 12158 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6906 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) &&
        (
#line 12140 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6917 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) &&
        (
#line 12125 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6928 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) &&
        (
#line 12109 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6939 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6440 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCountLeadingZerosInstruction
#line 6952 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosI_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6428 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCountLeadingZerosInstruction
#line 6969 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6477 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCountLeadingZerosInstruction
#line 7006 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosL_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6465 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCountLeadingZerosInstruction
#line 7023 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6514 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCountTrailingZerosInstruction
#line 7060 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosI_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6502 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCountTrailingZerosInstruction
#line 7077 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6546 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCountTrailingZerosInstruction
#line 7114 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosL_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6534 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCountTrailingZerosInstruction
#line 7131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(RAX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, CreateException_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        (
#line 6805 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 7187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        (
#line 6788 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 7209 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        
#line 3954 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 7256 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(INDIRECTNARROW, indirectNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirectNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_DECODEN_RREGN_, _DecodeN_rRegN__rule, c)
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2625 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7292 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2613 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7303 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2601 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7320 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2590 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2578 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7354 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2566 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7371 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2554 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7390 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2542 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7401 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2530 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7418 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2519 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7435 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2507 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2495 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7469 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, divI_rReg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RAX_REGL) && STATE__VALID_CHILD(_kids[1], IMML10) ) {
      unsigned int c = _kids[0]->_cost[NO_RAX_REGL]+_kids[1]->_cost[IMML10]+(5+8)*100;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, divL_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+30*100+10*100;
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, divL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModI_rReg_divmod_rule, c)
    }
}
void  State::_sub_Op_DivModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModL_rReg_divmod_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, encode_iso_array_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 6777 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull
#line 7568 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 6761 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull
#line 7578 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeHeapOop_rule, c)
      }
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) &&
        (
#line 12497 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!Compile::current()->use_rtm()
#line 7601 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RBX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLock_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) &&
        (
#line 12481 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Compile::current()->use_rtm()
#line 7610 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RBX_REGP]+300;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLockRTM_rule, c)
      }
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RAX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 2821 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 7629 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, fmaD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 2833 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 7642 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, fmaF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_HasNegatives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, has_negatives_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF2) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF2]+_kids[1]->_cost[RFLAGSREGUCF]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_rule, c)
      }
    }
}
void  State::_sub_Op_Jump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+350;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LSHIFTL_RREGL_IMMI2_IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LSHIFTL_RREGL_IMMI2_IMML32]+350;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_addr_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI2) &&
        (
#line 6855 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
false
#line 7715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI2]+350;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_offset_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI_32_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI, _LShiftI_no_rcx_RegI__SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI, _LShiftI_no_rcx_RegI__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_M1, _LShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI_RCX_REGI, _LShiftI_no_rcx_RegI_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI8, _LShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI1, _LShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_16, _LShiftI_rRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_24, _LShiftI_rRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__RCX_REGI, _LShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI8, _LShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI1, _LShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADUS_MEMORY__IMMI_24, _LShiftI__LoadUS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI_64_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI, _LShiftL_no_rcx_RegL__SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI, _LShiftL_no_rcx_RegL__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI_M1, _LShiftL_rRegL_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL_RCX_REGI, _LShiftL_no_rcx_RegL_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI8, _LShiftL_rRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI1, _LShiftL_rRegL_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__RCX_REGI, _LShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__IMMI8, _LShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__IMMI1, _LShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_RREGI__IMMI2, _LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI2, _LShiftL_rRegL_immI2_rule, c)
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADD_MEMORY_, _LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5448 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseXmmLoadAndClearUpper
#line 8031 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5435 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmLoadAndClearUpper
#line 8042 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, loadD_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADF_MEMORY_, _LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadKlass_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADNKLASS_MEMORY_, _LoadNKlass_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadNKlass_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadPLocked_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadP_rule, c)
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADN_MEMORY_, _LoadN_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadS_rule, c)
    }
}
void  State::_sub_Op_LoadBarrierSlowReg(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 12765 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseAVX == 3
#line 8220 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadBarrierSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadBarrierSlowRegZmm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 12726 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseAVX <= 2
#line 8241 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadBarrierSlowRegXmmAndYmm_rule, c)
      }
    }
}
void  State::_sub_Op_LoadBarrierWeakSlowReg(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 12847 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseAVX == 3
#line 8290 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadBarrierWeakSlowRegZmm_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadBarrierWeakSlowRegZmm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 12808 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseAVX <= 2
#line 8311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadBarrierWeakSlowRegXmmAndYmm_rule, c)
      }
    }
}
void  State::_sub_Op_MulAddS2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RREGI_RREGI]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulAddS2I_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulAddS2I_rReg_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+200;
        DFA_PRODUCTION__SET_VALID(RREGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, maxI_rReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_0_rule, c)
    }
}
void  State::_sub_Op_SetVectMaskI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2056 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
Matcher::has_predicated_vectors()
#line 8400 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, setMask_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 6686 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Matcher::post_store_load_barrier(n)
#line 8442 "dfa_x86.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+200;
        DFA_PRODUCTION__SET_VALID(RREGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, minI_rReg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, modI_rReg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, modL_rReg_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+125+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+125;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, MoveF2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+125+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 10847 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseXmmLoadAndClearUpper
#line 8630 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 10834 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmLoadAndClearUpper
#line 8647 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(RREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, MoveD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadSSL_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2483 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8733 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2471 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8744 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2471 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8761 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2459 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8778 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2448 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8812 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2424 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8846 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2412 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8865 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2400 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8876 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2400 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8893 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2388 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8910 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2377 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8927 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2365 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8944 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2365 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2353 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8978 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RAX_REGL) && STATE__VALID_CHILD(_kids[1], RAX_REGL) ) {
      unsigned int c = _kids[0]->_cost[NO_RAX_REGL]+_kids[1]->_cost[RAX_REGL]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulHiL_rReg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32]+300;
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+350;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+300;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+300;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 2722 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9265 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+150;
        DFA_PRODUCTION__SET_VALID(VLREGD, negD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, MoveVL2D_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2710 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 9276 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 2698 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 9295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+150;
        DFA_PRODUCTION__SET_VALID(VLREGF, negF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, MoveVL2F_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2687 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9306 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_OnSpinWait(const Node *n){
    {
      unsigned int c = 200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, onspinwait_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__IMMI, _OrI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_RREGI__LOADI_MEMORY_, _OrI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__RREGI, _OrI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADB_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_RREGI__LOADB_MEMORY_, _OrI_rRegI__LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADB_MEMORY__RREGI, _OrI__LoadB_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rorI_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rorI_rReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI8) &&
        (
#line 9007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9571 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI8) &&
        (
#line 9007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9606 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i1_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ORL__LOADL_MEMORY__IMML32, _OrL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORL_RREGL__LOADL_MEMORY_, _OrL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ORL__LOADL_MEMORY__RREGL, _OrL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_ANY_REGP_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_ANY_REGP_]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_castP2X_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _CASTP2X_ANY_REGP_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_CASTP2X_ANY_REGP_]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI_M1]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rorL_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI1]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rorL_rReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI8) &&
        (
#line 9152 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 9975 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI8]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI8) &&
        (
#line 9152 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 10007 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI8]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI_M1]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI1]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i1_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RAX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RAX_REGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RAX_REGL]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGP];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP, _PartialSubtypeCheck_rsi_RegP_rax_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGP]+1100;
        DFA_PRODUCTION__SET_VALID(RDI_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, partialSubtypeCheck_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 6581 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 10203 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6569 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 10220 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 6607 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 10257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6594 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 10274 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 10014 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 16
#line 10311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vpopcount16I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 10003 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 8
#line 10321 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vpopcount8I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 9992 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 4
#line 10331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vpopcount4I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) &&
        (
#line 9981 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vpopcntdq() && UsePopCountInstruction && n->as_Vector()->length() == 2
#line 10341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vpopcount2I_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5955 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==2
#line 10353 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5943 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==1
#line 10362 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5931 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==0
#line 10373 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5919 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==3
#line 10384 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, i2s_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__RCX_REGI, _RShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI8, _RShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI1, _RShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADUS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADUS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadS2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__RCX_REGI, _RShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__IMMI8, _RShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__IMMI1, _RShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(REGD, roundDouble_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(REGF, roundFloat_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 12557 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
SafepointMechanism::uses_thread_local_poll()
#line 10776 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_tls_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 12541 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Assembler::is_polling_page_far() && SafepointMechanism::uses_global_page_poll()
#line 10785 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_far_rule, c)
      }
    }
    if(         (
#line 12525 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!Assembler::is_polling_page_far() && SafepointMechanism::uses_global_page_poll()
#line 10795 "dfa_x86.cpp"
) ) {
      unsigned int c = 125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 137 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"
VM_Version::supports_cx8()
#line 10808 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+1000;
        DFA_PRODUCTION__SET_VALID(RAX_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, compareAndExchangeP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, compareAndExchangeP_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGN, compareAndExchangeN_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 75 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"
VM_Version::supports_cx8()
#line 10851 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_shenandoah_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_shenandoah_rule, c)
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_shenandoah_0_rule, c)
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 75 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"
VM_Version::supports_cx8()
#line 10884 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_shenandoah_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_shenandoah_0_rule, c)
    }
}
void  State::_sub_Op_ShenandoahReadBarrier(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) &&
        (
#line 56 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_shift() == Address::times_8)
#line 10903 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, shenandoahRBNarrowShift_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, shenandoahRBNarrowShift_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) &&
        (
#line 42 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_shift() == 0)
#line 10924 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+125;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, shenandoahRBNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, shenandoahRBNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+125;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, shenandoahRB_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, shenandoahRB_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD) &&
        (
#line 2795 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 11015 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 2783 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 11026 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2771 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 11043 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SqrtF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF) &&
        (
#line 2759 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 11062 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 2747 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 11073 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2735 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 11090 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI__LOADB_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_RREGI__LOADB_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorB_mem_rReg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADB_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADB_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorB_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_RREGI__LOADB_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_RREGI__LOADB_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orB_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADB_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADB_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orB_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__LOADB_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_RREGI__LOADB_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andB_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADB_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADB_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andB_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6199 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11155 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 6186 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseStoreImmI16
#line 11174 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI16]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6173 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11183 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmC0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6224 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11206 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM0_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD0) &&
        (
#line 6312 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11237 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD0]+25;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD0) &&
        (
#line 6300 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
!UseCompressedOops || (Universe::narrow_oop_base() != NULL)
#line 11246 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD0]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD0_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF]+50;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF0) &&
        (
#line 6262 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF0]+25;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__IMMI]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, negI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 7327 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 11433 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI1) &&
        (
#line 7300 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 11444 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 6123 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11482 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL__LOADL_MEMORY__IMML32]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, negL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 7449 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 11646 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML1) &&
        (
#line 7422 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 11657 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML32]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML0) &&
        (
#line 6148 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11695 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmL0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP31) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP31]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 6030 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 11718 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], ANY_REGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[ANY_REGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 6080 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() == NULL && Universe::narrow_klass_base() == NULL
#line 11741 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMNKLASS]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmNKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeNKlass_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RSI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RCX_REGI) &&
        (
#line 11115 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UL
#line 11772 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RSI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RDI_REGP_RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 11099 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LU
#line 11789 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareLU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 11083 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UU
#line 11824 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 11067 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LL
#line 11859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareL_rule, c)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compress_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RSI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RSI_REGP]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 11252 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 11924 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 11235 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 11941 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 11218 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 11976 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 11190 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 12011 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 11161 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 12046 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 11132 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 12081 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conL_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], RAX_REGI) &&
        (
#line 11269 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics
#line 12118 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofU_char_rule, c)
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, string_inflate_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2341 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12143 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2329 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12154 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2317 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12171 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2306 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12188 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2294 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12205 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2282 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 12222 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2270 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12241 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2258 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12252 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2246 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 12269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2235 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12286 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2223 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12303 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2211 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 12320 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_RREGI_RREGI, _SubI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_64) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_64]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_64_RCX_REGI, _SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_RCX_REGI, _SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RCX_REGI, _SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0__LOADI_MEMORY_, _SubI_immI0__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, negI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RREGI, _SubI_immI0_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__IMMI, _SubI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__RREGI, _SubI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0_RREGL, _SubL_immL0_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0__LOADL_MEMORY_, _SubL_immL0__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, negL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_SUBL__LOADL_MEMORY__IMML32, _SubL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL__LOADL_MEMORY__RREGL, _SubL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, subL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, subL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RBP_REGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) ) {
      unsigned int c = _kids[0]->_cost[NO_RBP_REGP]+_kids[1]->_cost[RBX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RBP_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[NO_RBP_REGP]+_kids[1]->_cost[RAX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(R15_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, tlsLoadP_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI_RCX_REGI, _URShiftI_no_rcx_RegI_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI1, _URShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI_32_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI, _URShiftI_no_rcx_RegI__SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI, _URShiftI_no_rcx_RegI__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI8, _URShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI_M1, _URShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__RCX_REGI, _URShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__IMMI8, _URShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__IMMI1, _URShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL_RCX_REGI, _URShiftL_no_rcx_RegL_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI1, _URShiftL_rRegL_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI_64_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI, _URShiftL_no_rcx_RegL__SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI, _URShiftL_no_rcx_RegL__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI8, _URShiftL_rRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI_M1, _URShiftL_rRegL_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__RCX_REGI, _URShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__IMMI8, _URShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__IMMI1, _URShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__IMMI, _XorI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI__LOADI_MEMORY_, _XorI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__RREGI, _XorI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADB_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI__LOADB_MEMORY_, _XorI_rRegI__LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADB_MEMORY__RREGI, _XorI__LoadB_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 9451 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12965 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9451 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13000 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 9436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13035 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13070 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI_IMMI_M1, _XorI_rRegI_immI_M1_rule, c)
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_XORL__LOADL_MEMORY__IMML32, _XorL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORL_RREGL__LOADL_MEMORY_, _XorL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_XORL__LOADL_MEMORY__RREGL, _XorL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL_IMML_M1) &&
        (
#line 9822 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13242 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_ADDL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9822 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13274 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9807 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13306 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9807 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 13338 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_RREGL_IMML_M1, _XorL_rRegL_immL_M1_rule, c)
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6116 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 13376 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6116 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 13386 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6105 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 13400 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6094 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13414 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6094 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13424 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6083 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 13438 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6072 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6072 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 13462 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6061 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0  && n->as_Vector()->length() == 16
#line 13476 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6051 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 13490 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6040 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13504 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6040 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13514 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6028 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13528 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6018 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 13542 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13556 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13566 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5995 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13580 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5985 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 13594 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6257 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 13610 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6257 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 13620 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6246 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 13634 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6235 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13648 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6235 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13658 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6224 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 13672 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6213 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13686 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6213 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13696 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6202 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13710 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6192 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 13724 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6181 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13738 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6181 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13748 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6170 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13762 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6160 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 13776 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6149 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13790 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6149 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13800 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6138 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0  && n->as_Vector()->length() == 2
#line 13814 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6128 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 13828 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECZ_VECZ) &&
        (
#line 9967 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 16
#line 13844 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_MULADDVS2VI_VECZ_VECZ]+10;
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladdadd32S16I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECZ_VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9967 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 16
#line 13854 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECZ_VECZ]+_kids[1]->_cost[VECZ]+10;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladdadd32S16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECY_VECY) &&
        (
#line 9955 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 8
#line 13868 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_MULADDVS2VI_VECY_VECY]+10;
        DFA_PRODUCTION__SET_VALID(VECY, vmuladdadd16S8I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECY_VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9955 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 8
#line 13878 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECY_VECY]+_kids[1]->_cost[VECY]+10;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmuladdadd16S8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECX_VECX) &&
        (
#line 9943 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 4
#line 13892 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_MULADDVS2VI_VECX_VECX]+10;
        DFA_PRODUCTION__SET_VALID(VECX, vmuladdadd8S4I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECX_VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9943 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 4
#line 13902 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECX_VECX]+_kids[1]->_cost[VECX]+10;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmuladdadd8S4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _MULADDVS2VI_VECD_VECD) &&
        (
#line 9931 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 2
#line 13916 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_MULADDVS2VI_VECD_VECD]+10;
        DFA_PRODUCTION__SET_VALID(VECD, vmuladdadd4S2I_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULADDVS2VI_VECD_VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9931 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_vnni() && UseAVX > 2 && n->as_Vector()->length() == 2
#line 13926 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULADDVS2VI_VECD_VECD]+_kids[1]->_cost[VECD]+10;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmuladdadd4S2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6366 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13940 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6366 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13954 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6355 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13968 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6344 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13982 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6344 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13996 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6333 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14010 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6322 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14024 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6322 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14038 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6311 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14052 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6301 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14066 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6290 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14080 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6290 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14094 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6279 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14108 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6269 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 14122 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5106 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14138 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd16I_reduction_reg_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5078 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14155 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5054 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 14190 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5030 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5010 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 14260 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4989 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 14295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4969 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14330 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4951 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 14365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4932 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 14400 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsadd2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6443 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14437 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6443 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14447 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6432 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14461 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6421 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 14475 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6421 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 14485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6410 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 14499 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6399 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6399 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14523 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6388 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6378 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 14551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5180 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14567 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd8L_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5157 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14583 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd4L_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5138 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd2L_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6552 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6552 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14659 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6541 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14673 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6530 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14687 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6530 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14697 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6519 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 14711 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6508 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14725 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6508 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6497 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14749 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6487 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14763 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6476 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14777 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6476 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14787 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6465 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6455 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 14815 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5323 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14831 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, radd16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5284 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14842 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, radd8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5261 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5238 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 14876 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5223 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14893 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5208 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 14910 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6629 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14929 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6629 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14939 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6618 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14953 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6607 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14967 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6607 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14977 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6596 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14991 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6585 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15005 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6585 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15015 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6574 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15029 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6564 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15043 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5447 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvadd8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5424 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15070 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5409 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5394 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 15104 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6772 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 15123 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6761 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 15133 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6750 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 15147 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6739 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 32
#line 15157 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6728 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 15171 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6717 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 15181 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6707 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 15195 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6696 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15209 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6685 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15219 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6675 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 15233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6664 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6653 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6643 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6913 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15287 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6902 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15297 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6891 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6880 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15321 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6869 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15335 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6858 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15345 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6848 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 15359 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6837 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15373 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6826 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15383 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6816 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15397 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6805 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15411 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6794 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15421 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6784 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15435 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7022 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15451 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7011 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15461 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7000 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15475 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6989 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6978 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15499 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6967 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15509 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6957 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15523 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6946 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6935 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6925 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15561 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7099 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15577 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7088 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15587 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7077 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15601 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7066 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15611 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7055 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15625 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7044 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15635 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7034 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7208 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15665 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7197 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7186 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15689 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7175 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15699 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7164 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7153 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15723 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7143 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7132 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15751 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7121 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15761 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7111 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15775 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7285 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15791 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7274 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7263 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15815 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7252 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15825 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7241 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15839 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7230 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15849 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7220 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15863 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7428 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7428 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15889 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7417 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15903 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7406 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15917 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7406 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15927 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7395 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 15941 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7384 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7384 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7373 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15979 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7363 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 15993 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7352 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7352 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7341 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16031 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7331 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16045 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7320 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7320 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16069 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7309 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16083 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7299 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16097 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7603 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16113 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7603 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16123 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7592 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16137 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7581 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 16151 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7581 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 16161 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7570 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 16175 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7493 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16189 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7493 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16199 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7482 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16213 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7472 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 4
#line 16227 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7461 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16241 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7461 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16251 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7450 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16265 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7440 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 2
#line 16279 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5600 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 16295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul16I_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5572 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1
#line 16312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5548 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16347 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5525 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 16382 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5505 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16417 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5486 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 16452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsmul2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7559 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16489 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7559 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16499 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7548 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7537 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7537 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7526 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7515 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7515 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16575 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7504 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16589 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5674 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16605 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul8L_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5651 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16621 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul4L_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5632 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16653 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul2L_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7712 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16687 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7712 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16697 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7701 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16711 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7690 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16725 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7690 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7679 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16749 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7668 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16763 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7668 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16773 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7657 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16787 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7647 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 16801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7636 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16815 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7636 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16825 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7625 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16839 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7615 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 16853 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5817 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 16869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, rvmul16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5778 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16880 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5755 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16897 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5732 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 16914 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5717 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16931 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5702 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 16948 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul2F_reduction_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGF) || _cost[VLREGF] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGF, MoveF2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7789 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16967 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7789 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16977 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7778 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16991 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7767 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17005 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7767 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17015 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7756 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17029 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7745 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17043 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7745 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17053 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7734 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17067 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7724 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17081 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_MulReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], LEGVECZ) &&
        (
#line 5941 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 17097 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[LEGVECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvmul8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5918 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17108 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5903 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 17125 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5888 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 17142 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(VLREGD) || _cost[VLREGD] > c+100) {
        DFA_PRODUCTION__SET_VALID(VLREGD, MoveD2VL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulAddVS2VI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECZ_VECZ, _MulAddVS2VI_vecZ_vecZ_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECY_VECY, _MulAddVS2VI_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECX_VECX, _MulAddVS2VI_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD];
        DFA_PRODUCTION__SET_VALID(_MULADDVS2VI_VECD_VECD, _MulAddVS2VI_vecD_vecD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9918 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmuladd32S16I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9907 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmuladd16S8I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9896 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17197 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmuladd8S4I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9886 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 2 && UseAVX == 0 && n->as_Vector()->length() == 4
#line 17207 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, smuladd8S4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9875 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17221 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmuladd4S2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9865 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 2 && UseAVX == 0 && n->as_Vector()->length() == 2
#line 17231 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, smuladd4S2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_FmaVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 9773 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 17247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 9760 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 17257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 9747 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 17271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 9734 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 17281 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 9720 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 17295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 9707 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 17305 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_FmaVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 9851 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 17321 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 9838 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 17331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 9825 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 17345 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 9812 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 17355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 9799 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 17369 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 9786 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 17379 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7932 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 17395 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7921 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 17405 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7910 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7899 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7888 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17443 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7877 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17453 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7867 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17467 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7856 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17481 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7845 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17491 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7835 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17505 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8009 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17521 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7998 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17531 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7987 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17545 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7976 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7965 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17569 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7954 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7944 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SqrtVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8092 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8081 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17619 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8070 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17633 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8059 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17643 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8048 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17657 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8037 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17667 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_SqrtVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8180 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17683 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8169 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17693 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8158 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17707 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8147 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17717 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8136 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17731 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8125 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17741 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8114 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17755 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) &&
        (
#line 8103 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17765 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8353 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8342 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17805 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8331 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 17819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8320 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 17829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8309 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17843 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8298 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17853 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8288 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17867 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8278 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17881 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8267 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17895 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8256 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17905 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8246 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17919 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8236 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17933 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8225 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17947 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8214 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17957 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8204 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8194 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8482 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18001 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8471 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18011 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8460 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18025 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8449 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18035 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8438 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18049 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8427 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8417 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18073 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8407 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8396 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8385 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18111 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8375 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18125 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8365 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18139 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8569 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18155 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8558 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8547 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 18179 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8536 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 18189 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8525 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18203 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8514 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18213 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8504 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18227 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8494 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18241 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9135 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9124 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18267 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9113 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18281 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9102 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18291 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9091 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18305 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9080 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18315 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9070 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18329 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9060 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18343 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9049 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9038 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18367 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9028 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18381 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9018 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18395 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9007 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18409 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8996 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8986 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18433 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8976 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18447 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9264 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18463 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9253 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18473 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9242 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18487 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9231 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18497 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9220 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18511 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9209 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18521 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9199 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18535 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9189 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18549 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9178 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18563 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9167 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18573 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9157 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18587 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9147 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18601 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8746 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8735 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18627 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8724 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18641 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8713 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 16
#line 18651 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8702 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18665 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8691 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 18675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8681 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18689 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8671 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18703 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8660 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18717 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8649 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18727 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8639 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18741 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8629 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18755 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8618 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18769 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8607 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18779 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8597 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18793 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8587 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18807 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8875 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18823 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8864 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18833 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8853 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18847 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8842 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18857 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8831 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18871 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8820 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18881 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8810 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18895 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8800 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8789 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18923 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8778 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18933 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8768 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18947 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8758 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8962 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18977 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8951 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18987 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8940 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 19001 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8929 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 19011 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8918 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19025 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8907 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 19035 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8897 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19049 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8887 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 19063 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9409 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9409 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19089 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9398 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19103 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9387 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19117 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9387 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19127 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9376 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19141 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9365 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19155 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9365 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9354 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19179 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9344 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 19193 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9333 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19207 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9333 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19217 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9322 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19231 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9312 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 19245 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9301 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19259 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9301 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9290 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19283 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9280 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 19297 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9551 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19313 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9551 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19323 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9540 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9529 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9529 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19361 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9518 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19375 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9507 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19389 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9507 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19399 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9496 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19413 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9486 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 19427 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9475 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9475 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19451 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9464 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9454 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 19479 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9443 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9443 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19503 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9432 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19517 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9422 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 19531 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9693 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9693 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19557 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 9682 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9671 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19585 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9671 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19595 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 9660 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9649 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19623 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9649 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19633 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9638 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19647 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 9628 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 16
#line 19661 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9617 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9617 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19685 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9606 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19699 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 9596 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 8
#line 19713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9585 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19727 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 9585 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9574 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19751 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9564 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length_in_bytes() == 4
#line 19765 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADVECTOR_MEMORY_, _LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 3009 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() > 4
#line 19785 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_qword_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2996 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() <= 4
#line 19795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_dword_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2954 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 32
#line 19809 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECY, loadV32_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2912 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 16
#line 19819 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECX, loadV16_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2880 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 8
#line 19829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2848 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 4
#line 19839 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECS, loadV4_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 3098 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() > 4
#line 19851 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_qword_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 3086 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() <= 4
#line 19860 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_dword_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 3075 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 32
#line 19871 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECY]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 3064 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 16
#line 19882 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECX]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 3053 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 8
#line 19893 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECD]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 3042 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 4
#line 19904 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECS]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV4_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4358 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2
#line 19917 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4345 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 19927 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4332 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 19941 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4319 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 19951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4308 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 19961 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4297 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 19975 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4286 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 19989 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4275 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20003 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4264 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4253 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20031 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4242 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20045 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 4231 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3970 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32
#line 20065 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3960 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 20079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3950 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20093 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3940 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20107 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3929 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3919 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20135 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3904 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20149 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3890 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20163 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3264 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 20177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3250 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20191 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3238 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 20205 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3220 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 20219 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3200 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && !VM_Version::supports_avx512vlbw()
#line 20233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl64B_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3184 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3166 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20261 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3152 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 20275 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3136 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 20289 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3124 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 20303 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3112 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 20317 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4497 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2
#line 20333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4484 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20343 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4471 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4458 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20367 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4447 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20377 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4436 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2 && VM_Version::supports_avx512bw()
#line 20391 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4425 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20405 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4414 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4403 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20433 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4392 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20447 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 4381 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20461 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4370 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vlbw()
#line 20471 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4047 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 20485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4037 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20499 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4027 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4017 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20527 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4006 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3996 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3983 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20565 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECS) || _cost[LEGVECS] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECS, MoveVecS2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3418 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3402 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3384 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 20607 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl32S_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3370 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 20621 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3356 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 20635 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3340 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 20649 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3328 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 20663 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3316 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 20677 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3302 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 20691 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3292 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 20705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3280 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vlbw()
#line 20719 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4614 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4601 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20745 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4588 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20759 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4575 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20769 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4564 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20779 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4553 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20793 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4542 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20807 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4531 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4520 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20835 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4509 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 20849 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4117 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20863 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4107 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20877 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4097 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20891 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4086 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4073 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20915 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4060 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20929 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3538 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 20943 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3524 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20957 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3512 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3498 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 20985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3482 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 20999 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16I_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3470 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21013 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3456 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3446 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21041 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3434 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4746 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21071 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4735 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21081 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4724 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21095 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4713 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21105 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4700 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21115 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4687 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21129 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 4639 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21143 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 4628 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21157 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4185 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21171 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4175 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21185 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4162 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21199 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 4131 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21213 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3684 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21227 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3670 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21241 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3654 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21255 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3640 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 3583 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21283 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8L_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 3569 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21297 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3555 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && !VM_Version::supports_avx512vlbw()
#line 21311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4838 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21327 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4826 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4814 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 21347 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4802 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 21357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4791 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21367 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4780 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 21381 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4769 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21395 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4758 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21409 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 4208 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 21423 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 4198 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21437 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3792 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX < 3
#line 21451 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3782 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 21465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3772 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 21479 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3758 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vl()
#line 21493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 3744 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21507 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl16F_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3732 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21521 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGF) &&
        (
#line 3720 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21535 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3710 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21549 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3700 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21563 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECD) || _cost[LEGVECD] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECD, MoveVecD2Leg_rule, c+100)
      }
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4918 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4906 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 21589 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4894 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 21599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4883 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21609 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4872 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 21623 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, MoveVecZ2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4861 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21637 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4850 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2 && VM_Version::supports_avx512vl()
#line 21651 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 4219 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 21665 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3876 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 21679 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3866 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 21693 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3851 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 21707 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 3837 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21721 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(LEGVECZ) || _cost[LEGVECZ] > c) {
        DFA_PRODUCTION__SET_VALID(LEGVECZ, Repl8D_rule, c)
      }
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c+100) {
        DFA_PRODUCTION__SET_VALID(VECZ, MoveLeg2VecZ_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3825 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 21735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VLREGD) &&
        (
#line 3813 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21749 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VLREGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECY) || _cost[LEGVECY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECY, MoveVecY2Leg_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3803 "/tmp/B.mdxsxq30/BUILD/jdk12u-jdk-12.0.2-ga/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 21763 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(LEGVECX) || _cost[LEGVECX] > c+100) {
        DFA_PRODUCTION__SET_VALID(LEGVECX, MoveVecX2Leg_rule, c+100)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecS: { _sub_Op_VecS(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_VecY: { _sub_Op_VecY(n);
    break;
  }
  case Op_VecZ: { _sub_Op_VecZ(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveVD: { _sub_Op_CMoveVD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveVF: { _sub_Op_CMoveVF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapB: { _sub_Op_CompareAndSwapB(n);
    break;
  }
  case Op_CompareAndSwapS: { _sub_Op_CompareAndSwapS(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_WeakCompareAndSwapB: { _sub_Op_WeakCompareAndSwapB(n);
    break;
  }
  case Op_WeakCompareAndSwapS: { _sub_Op_WeakCompareAndSwapS(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapN: { _sub_Op_WeakCompareAndSwapN(n);
    break;
  }
  case Op_CompareAndExchangeB: { _sub_Op_CompareAndExchangeB(n);
    break;
  }
  case Op_CompareAndExchangeS: { _sub_Op_CompareAndExchangeS(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_CompareAndExchangeN: { _sub_Op_CompareAndExchangeN(n);
    break;
  }
  case Op_GetAndAddB: { _sub_Op_GetAndAddB(n);
    break;
  }
  case Op_GetAndAddS: { _sub_Op_GetAndAddS(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetB: { _sub_Op_GetAndSetB(n);
    break;
  }
  case Op_GetAndSetS: { _sub_Op_GetAndSetS(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_DivModL: { _sub_Op_DivModL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_HasNegatives: { _sub_Op_HasNegatives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_Jump: { _sub_Op_Jump(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_LoadBarrierSlowReg: { _sub_Op_LoadBarrierSlowReg(n);
    break;
  }
  case Op_LoadBarrierWeakSlowReg: { _sub_Op_LoadBarrierWeakSlowReg(n);
    break;
  }
  case Op_MulAddS2I: { _sub_Op_MulAddS2I(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_SetVectMaskI: { _sub_Op_SetVectMaskI(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OnSpinWait: { _sub_Op_OnSpinWait(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowMulI: { _sub_Op_OverflowMulI(n);
    break;
  }
  case Op_OverflowAddL: { _sub_Op_OverflowAddL(n);
    break;
  }
  case Op_OverflowSubL: { _sub_Op_OverflowSubL(n);
    break;
  }
  case Op_OverflowMulL: { _sub_Op_OverflowMulL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PopCountVI: { _sub_Op_PopCountVI(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeP: { _sub_Op_ShenandoahCompareAndExchangeP(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeN: { _sub_Op_ShenandoahCompareAndExchangeN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapN: { _sub_Op_ShenandoahCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapP: { _sub_Op_ShenandoahCompareAndSwapP(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapN: { _sub_Op_ShenandoahWeakCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapP: { _sub_Op_ShenandoahWeakCompareAndSwapP(n);
    break;
  }
  case Op_ShenandoahReadBarrier: { _sub_Op_ShenandoahReadBarrier(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_SqrtF: { _sub_Op_SqrtF(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddReductionVI: { _sub_Op_AddReductionVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddReductionVL: { _sub_Op_AddReductionVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddReductionVF: { _sub_Op_AddReductionVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_AddReductionVD: { _sub_Op_AddReductionVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulReductionVI: { _sub_Op_MulReductionVI(n);
    break;
  }
  case Op_MulVL: { _sub_Op_MulVL(n);
    break;
  }
  case Op_MulReductionVL: { _sub_Op_MulReductionVL(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulReductionVF: { _sub_Op_MulReductionVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_MulReductionVD: { _sub_Op_MulReductionVD(n);
    break;
  }
  case Op_MulAddVS2VI: { _sub_Op_MulAddVS2VI(n);
    break;
  }
  case Op_FmaVD: { _sub_Op_FmaVD(n);
    break;
  }
  case Op_FmaVF: { _sub_Op_FmaVF(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_SqrtVD: { _sub_Op_SqrtVD(n);
    break;
  }
  case Op_SqrtVF: { _sub_Op_SqrtVF(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
